(
s.options.device_("Steinberg UR22mkII ");
s.options.memSize = 128 *1024;
s.boot;
)

(
SynthDef(\tbnsynth, { arg out=0, zeroed=0.000036,
	freq1=3000,rq1=1,gain1=0,
	freq2=5000,rq2=1,gain2=0,
	freq3=5000,rq3=1,gain3=0,
	vol=0.056, gainA = 1, gainB = 1, mute = 1;
    var inA, chainA, inB, chainB, chain;
    inA = SoundIn.ar(0);
	inB =  SoundIn.ar(1);
	inA = gainA * inA;
	inB = gainB * inB;
    chainA = FFT(LocalBuf(2048), inA);
    chainB = FFT(LocalBuf(2048), inB);
	chain = PV_MagDiv(chainA, chainB,zeroed);
	chain = IFFT(chain);
	chain = HPF.ar(chain,500);
	chain = HPF.ar(chain,100);
	chain = FreeVerb.ar(chain,0.2);
	chain = LPF.ar(chain,7000);
	chain = BPeakEQ.ar(chain, freq1,rq1,gain1);
	chain = BPeakEQ.ar(chain, freq2,rq2,gain2);
	chain = BPeakEQ.ar(chain, freq3,rq3,gain3);
	chain = vol * mute * chain ;
	chain = Limiter.ar(chain, 0.99);
	Out.ar(out, chain.dup);
}).send;
)

(//interface de controle (aqui que da play no código)
a = Synth.new(\tbnsynth);
w=Window.new(\eq, Rect(0,10,1000,420)).front;
EZKnob.new(w,Rect(10,10,100,100),"frq",ControlSpec.new(500,10000,\exp,0,750), { |ez| a.set(\freq1, ez.value)});
EZKnob.new(w,Rect(110,10,100,100),"q",ControlSpec.new(0,1,\lin,0,0.5), { |ez| a.set(\rq1, ez.value) });
EZKnob.new(w,Rect(210,10,100,100),"gain",ControlSpec.new(-24,6,\lin,0,-12), { |ez| a.set(\gain1, ez.value) } );

EZKnob.new(w,Rect(10,110,100,100),"frq",ControlSpec.new(500,10000,\exp,0,2000),{ |ez| a.set(\freq2, ez.value) } );
EZKnob.new(w,Rect(110,110,100,100),"q",ControlSpec.new(0,1,\lin,0,0.5),{ |ez| a.set(\rq2, ez.value) } );
EZKnob.new(w,Rect(210,110,100,100),"gain",ControlSpec.new(-24,6,\lin,0,-12),{ |ez| a.set(\gain2, ez.value) } );

EZKnob.new(w,Rect(10,210,100,100),"frq",ControlSpec.new(500,10000,\exp,0,6000),{ |ez| a.set(\freq2, ez.value) } );
EZKnob.new(w,Rect(110,210,100,100),"q",ControlSpec.new(0,1,\lin,0,0.5),{ |ez| a.set(\rq2, ez.value) } );
EZKnob.new(w,Rect(210,210,100,100),"gain",ControlSpec.new(-24,6,\lin,0,-12),{ |ez| a.set(\gain2, ez.value) } );

EZSlider.new(w,Rect(10,335,400,20),"volume",ControlSpec.new(-150,12,\lin,0,-24), { |ez| a.set(\vol, ez.value.dbamp)});
EZSlider.new(w,Rect(10,355,400,20),"zeroed",ControlSpec.new(0.1,1,\lin,0,0.36), { |ez| a.set(\zeroed, ez.value*10e-05)});
EZSlider.new(w,Rect(10,375,400,20),"gainA",ControlSpec.new(-150,12,\lin,0,0), { |ez| a.set(\gainA, ez.value.dbamp)});
EZSlider.new(w,Rect(10,395,400,20),"gainB",ControlSpec.new(-150,12,\lin,0,0), { |ez| a.set(\gainB, ez.value.dbamp)});
Button.new(w,Rect(420,335,30,30)).states_([ ["ON"],["OFF"] ]).action_({ arg but; if(but.value==0,{a.set(\mute,1);},{a.set(\mute,0);}) });

ServerMeterView.new(s,w,Point(320,10,200,200),2,2);

z = UserView.new(w, Rect(470,10,511,400));
f=FreqScopeView.new(z,511@400,s);
f.active_(true);
f.inBus = 0;
f.dbRange = 144;
f.freqMode = 1;
w.onClose_({f.kil});
s.freqscope;
CmdPeriod.doOnce({if(w.isClosed.not, {w.close})});
)
